
function Degrees (  ) { }
Degrees.standard = [0, 45, 90, 135, 180, 225, 270, 315 ];

function Radians () {}
Radians.standard = [0, (Math.PI / 4), (Math.PI / 2), ((3 * Math.PI)/ 4), Math.PI, ((5 * Math.PI)/ 4), ((3 * Math.PI)/ 2), ((7 * Math.PI)/ 4), (2 * Math.PI)];
 
//	this.canvases[num] = new ShapeCanvas(new_color, type, new_container, new_canvas, left, right, top, bottom);
  
/**
   * ShapeCanvas
   *   ShapeCanvas is a box which has in it the Canvas object. Each shape created through the GUI makes its own ShapeCanvas.
   */
function ShapeCanvas(color, shape, div, canvas, left_x, right_x, upper_y, lower_y) {
	this.canvas_id = canvas;
	this.canvas = new Rect();
	this.container_id = div;
	this.container = new Rect();
	this.shape = new Shape( shape, this.canvas_id, color, 2, 1);

	this.SetContainer(left_x, right_x, upper_y, lower_y);
}
//type, id, color, x_padding, y_padding

ShapeCanvas.prototype.Calculate = function () { return this.shape.Calculate( this.canvas, this.container, this.GetSideSpace(), this.GetTopSpace() ); };
ShapeCanvas.prototype.Draw = function ( ) { return this.shape.Draw(); };
ShapeCanvas.prototype.toJSON = function( ) { return this.shape.toJSON( this.container ); }; 
ShapeCanvas.prototype.ChangeMe = function ( ) {
	var canvas = $("#"+this.canvas_id);
	var container = $("#"+this.container_id);

	var top = findInt(container.css("top"));
	var left = findInt(container.css("left"));
	var height = findInt(container.css("height"));
	var width =  findInt(container.css("width"));

	canvas.css("top", top);
	canvas.css("left", left);
	canvas.css("height", height);
	canvas.css("width", width);

	canvas.attr("height", height);
	canvas.attr("width",width);

	this.SetContainer(left, left+width, top, top+height);
	this.Draw(this.GetColor(), this.canvas_id);
}	
ShapeCanvas.prototype.ResizeMe = function( new_height, new_width, new_top, new_left ) {
	var canvas = $("#"+this.canvas_id);
	var container = $("#"+this.container_id);
	
	canvas.css("top", new_top);
	canvas.css("left", new_left);
	canvas.css("height", new_height);
	canvas.css("width", new_width);

	canvas.attr("height", new_height);
	canvas.attr("width", new_width);

	this.SetContainer(new_left, new_left+new_width, new_top, new_top+new_height);
	this.Draw(this.GetColor(), this.canvas_id);
	

	
	

};
ShapeCanvas.prototype.SetColor = function(new_color) { this.shape.SetColor(new_color); };
ShapeCanvas.prototype.GetColor = function() { return this.shape.GetColor(); };
ShapeCanvas.prototype.SetContainer = function (left_x, right_x, upper_y, lower_y) {
		var old_height = this.container.GetHeight();
		var old_width = this.container.GetWidth();
		
		this.container.SetPoints(left_x, right_x, upper_y, lower_y);
		
		if ( (old_height != this.container.GetHeight()) || (old_width != this.container.GetWidth()) ) { 
			this.SetArea(0, right_x - left_x, 0, lower_y - upper_y);
			this.Draw();
		}
	};
ShapeCanvas.prototype.SetArea = function ( left_x, right_x, upper_y, lower_y ) {
	this.canvas.SetPoints(left_x, right_x, upper_y, lower_y);
	this.shape.Calculate( this.canvas, this.container );
};

ShapeCanvas.prototype.SetLine = function( int_width ) { this.shape.SetLine( int_width ); };

  








//todo
//find formula for ellipses
// using bezeir curves??

function RemovePX(str) {
	var where = str.indexOf("px");
	ans = str.substring(0,where);
	ans *= 1;
	return ans;
};
